package com.huiju.estateagents.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.huiju.estateagents.entity.TaPerson;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.huiju.estateagents.po.PersonPO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 人员表 Mapper 接口
 * </p>
 *
 * @author jobob
 * @since 2019-05-10
 */
@Mapper
public interface TaPersonMapper extends BaseMapper<TaPerson> {
    List<Map<String,Object>> selectCardList(IPage<Map<String,Object>> page, @Param("personType") String personType, @Param("status") int status);

    int setFieldIncrement(@Param("personId") String personId, @Param("field") String field, @Param("increment") int increment);

    TaPerson getSalesExecutive();

    List<TaPerson> getPersonByOpenId(@Param("openId") String openId);

    List<Map<String, Object>> selectBuildingConsultants(@Param("buildingId") String buildingId, @Param("personType") String personType, @Param("status") int status);

    IPage<TaPerson> selectCustomer(IPage<TaPerson> page);

    TaPerson getById(@Param("personId") String personId);


    List<String>getUserProjects(@Param("personId") String personId);

    TaPerson selectByIdPerson(@Param("openid") String openid);

    List<String> getConsultantByName(@Param("name")String name);

    String getConsultantByTel(@Param("tel")String tel);

    List<Map<String,Object>> selectCardListofMine(IPage<Map<String,Object>> page, @Param("personType") String personType, @Param("status") int status,@Param("personIds")List<String> personIds);

    //---------- 用户总数 start ------------

    /**
     * 总用户数
     * @param personType
     * @return
     */
    @Select("select count(1) from ta_person where person_type = #{personType}")
    Integer selectUserCount(@Param("personType") String personType);

    /**
     * 总注册数
     * @param personType
     * @return
     */
    @Select("select count(1) from ta_person where person_type = #{personType} and phone is not null")
    Integer selectRegisteredCount(@Param("personType") String personType);

    /**
     * 根据时间段查询
     * @param personType
     * @return
     */
    Integer selectRecentlyCount(@Param("personType") String personType, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    //---------- 用户总数 end ------------

    /**
     * 用户行为
     * @param personType
     * @param startDate
     * @param endDate
     * @return
     */
    List<PersonPO> selectUserBehavior(@Param("personType") String personType, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    /**
     * 活跃用户数 / 最近新增的用户数
     * @param personType
     * @param dateType
     * @return
     */
    List<Map<String, Object>> selectActiveUserCount(@Param("personType") String personType, @Param("dateType") String dateType, @Param("startDate")Date startDate, @Param("endDate")Date endDate);


    /**
     * 性别比例
     * @param personType
     * @return
     */
    @Select("select sex, count(1) from ta_person where person_type = #{personType} GROUP BY sex")
    List<Map<String, Object>> selectSexUser(@Param("personType") String personType);








}
